//Var GET and funtions to update it
var currentTime = new Date()  
var velocityFlag = 0;
var baseLayer = 'Aerial';
var preset = 2; //define default preset to be displayed
var basel = 1;
var infoMarker = {}; //Define if a coordinate window is already displayed
let params = (new URL(document.location)).searchParams;
    if(params.has('json') == true) {currentjson = params.get('json');}
    if(params.has('baseLayer') == true) {baseLayer = params.get('baseLayer');}

//Check if zoom and coordinate are defined un GET params from URL and update it if true
function redefineCenter() {
    let paramZ = (new URL(document.location)).searchParams;
    //check if zoom or coordinate param exist, then set-view for the map
    if(paramZ.has('zoom') == true) {zoomS = paramZ.get('zoom');} 
    if(paramZ.has('lat') == true) {latS = paramZ.get('lat');} 
    if(paramZ.has('lng') == true) {lngS = paramZ.get('lng');} 
    }
 redefineCenter();



//Function to update GET param
function setParam(name, value) {
    const params = new URLSearchParams(window.location.search);
    params.set(name, value);
    window.history.replaceState({}, "", decodeURIComponent(`${window.location.pathname}?${params}`));
}

//imagery argis map
var m_color = new L.tileLayer('https://server.arcgisonline.com/ArcGIS/rest/services/World_Imagery/MapServer/tile/{z}/{y}/{x}', { 
            attribution: '',
            maxNativeZoom: 17
});

//OSM Map
var m_mono = new L.tileLayer('https://tiles.stadiamaps.com/tiles/alidade_smooth_dark/{z}/{x}/{y}{r}.{ext}', {
    maxZoom: 14,
    attribution:'',
     ext: 'png'
});

//local map
var m_local = new L.tileLayer("./map", { 
            attribution: '',
            maxNativeZoom: 14
});

//Open Sea Map Layer
var layer_osm = new L.tileLayer('https://tiles.openseamap.org/seamark/{z}/{x}/{y}.png', { 
            attribution: '',
});

//Set base layer from get
if (baseLayer == "Aerial" ) {baseLayer = m_color;}
if (baseLayer == "Dark Map" ) {baseLayer = m_mono;}
if (baseLayer == "Local Map" ) {baseLayer = m_local;}

var map = L.map('map', {
    center: [latS,lngS],
    zoom: zoomS,
    minZoom: 11,
    maxZoom: 13,
    zoomControl: true,
    layers: [baseLayer, layer_osm]
});

//BaseLayer
var Map_BaseLayer = {
    "Aerial": m_color,
    "Dark Map": m_mono,
    "Local Map": m_local
};

//AddLayer
var Map_AddLayer = {
	//"Open Chart": layer_chart,
    "Buoys Layer": layer_osm,
};

//LayerControl
L.control.layers(
    Map_BaseLayer,
    Map_AddLayer,
    {
    collapsed: false
    }
).addTo(map);

//Remove leaflet attribution
document.getElementsByClassName( 'leaflet-control-attribution' )[0].style.display = 'none';

//Save and set bae layer on change
map.on('baselayerchange', function(e){
            setParam('baseLayer', e.name );
        })

map.on('layeradd', function(e){
  if ( map.hasLayer(layer_osm) == true) {setParam('buoy', 1 );}
            
        })

map.on('layerremove', function(e){
  if ( map.hasLayer(layer_osm) == false) {setParam('buoy', 0 );}
            
        })

if(params.has('buoy') == true) {if (params.get('buoy') == 1) {map.addLayer(layer_osm)};}


// Automatic button from GET URL
window.onload = function updGet() {
    //catch url
    let params = (new URL(document.location)).searchParams;
    if(params.has('basel') == true) {basel = params.get('basel');}
    if(params.has('modex') == true) {currentjson = params.get('modex');}   
}




//Update zoom level in url to keep it when refresh

map.on("zoomend", showZoom);
map.on("moveend", showCenter);
map.on("movestart", removeInfo);

 function showZoom() {
 	setParam('zoom', map.getZoom());
}

 function showCenter() {
 	var latlng = map.getCenter();
 	setParam('lat', latlng.lat);
 	setParam('lng', latlng.lng);
}

function removeInfo() {if (infoMarker != undefined) {map.removeLayer(infoMarker);};}


//// Here start the velocity layer

var velocityLayer; //This is the var containing the new velocity layer  // Original function derived from vleaflet-velocity-ts

function loadVelocityLayer(data) // we initial a function to load velocity, this function wrap the json loading to be able to reload the layer with updated data at any time. We set the json name as param
{
       //$.get json is a ajax/jsquery function, .done start a following funtion

        velocityLayer = window.L.velocityLayer(  // we create a new constant VlocityLayer feeded by the function window.L.velocity layer calling the leafle windy function 
        {
        displayValues: true, //Option display value, will display on hover mouse speed on map
        displayOptions: { velocityType: "", displayPosition: "bottomleft", displayEmptyString: "No data",speedUnit: "kt",}, //display option text and position
        data: data,  //feeding datas from data
        maxVelocity: 5,  //
        velocityScale: 0.08 // arbitrary default 0.005
        });
        if (velocityLayer != null) {
        map.addControl(velocityLayer);
        } 

        //The if (velocitylayer != null) is a "lazy way" to corect a bug and be sure to don't load a new Velocity layer before the previous one was finished / removed. 
        //This is due to Synchronous way JS work and the zoom start/end on click. The right way will be probably to make asynchronous function but i'm tired to deal with these problems. 
        // This make slow down the possibility to repeat simultaneous Zoom in/out. And i'm surprised yself it work like it. I did it without realy knowing what i realy do.
        

} 


//We load our fuction to initiate velocity layer with tile
jsonMerge(map.getBounds().getWest(), map.getBounds().getNorth(), map.getBounds().getSouth(), map.getBounds().getEast(), map.getZoom());


//We manage the velocity layer with map control to remove/reload the layer. 
map.on('zoomstart', function() { 
    map.removeControl(velocityLayer);
    velocityLayer = null; // required to avoid bug
 }); 

 map.on('dragstart', function() { 
    map.removeControl(velocityLayer);
    velocityLayer = null; // required to avoid bug
});

map.on('zoomend', function() { 
    jsonMerge(map.getBounds().getWest(), map.getBounds().getNorth(), map.getBounds().getSouth(), map.getBounds().getEast(), map.getZoom());
});

map.on('dragend', function() { 
        jsonMerge(map.getBounds().getWest(), map.getBounds().getNorth(), map.getBounds().getSouth(), map.getBounds().getEast(), map.getZoom());
});


